// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/LoadCarrierWithFillingLevel.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/load_carrier_with_filling_level__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `id`
// Member `type`
#include "rosidl_runtime_c/string_functions.h"
// Member `outer_dimensions`
// Member `inner_dimensions`
#include "rc_reason_msgs/msg/detail/box__functions.h"
// Member `rim_thickness`
// Member `rim_ledge`
#include "rc_reason_msgs/msg/detail/rectangle__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose_stamped__functions.h"
// Member `overall_filling_level`
// Member `cells_filling_levels`
#include "rc_reason_msgs/msg/detail/cell_filling_level__functions.h"
// Member `filling_level_cell_count`
#include "rc_reason_msgs/msg/detail/grid_size__functions.h"

bool
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__init(rc_reason_msgs__msg__LoadCarrierWithFillingLevel * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__init(&msg->type)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // outer_dimensions
  if (!rc_reason_msgs__msg__Box__init(&msg->outer_dimensions)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // inner_dimensions
  if (!rc_reason_msgs__msg__Box__init(&msg->inner_dimensions)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // rim_thickness
  if (!rc_reason_msgs__msg__Rectangle__init(&msg->rim_thickness)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // rim_step_height
  // rim_ledge
  if (!rc_reason_msgs__msg__Rectangle__init(&msg->rim_ledge)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__init(&msg->pose)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // overfilled
  // overall_filling_level
  if (!rc_reason_msgs__msg__CellFillingLevel__init(&msg->overall_filling_level)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // cells_filling_levels
  if (!rc_reason_msgs__msg__CellFillingLevel__Sequence__init(&msg->cells_filling_levels, 0)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  // filling_level_cell_count
  if (!rc_reason_msgs__msg__GridSize__init(&msg->filling_level_cell_count)) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(rc_reason_msgs__msg__LoadCarrierWithFillingLevel * msg)
{
  if (!msg) {
    return;
  }
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // type
  rosidl_runtime_c__String__fini(&msg->type);
  // outer_dimensions
  rc_reason_msgs__msg__Box__fini(&msg->outer_dimensions);
  // inner_dimensions
  rc_reason_msgs__msg__Box__fini(&msg->inner_dimensions);
  // rim_thickness
  rc_reason_msgs__msg__Rectangle__fini(&msg->rim_thickness);
  // rim_step_height
  // rim_ledge
  rc_reason_msgs__msg__Rectangle__fini(&msg->rim_ledge);
  // pose
  geometry_msgs__msg__PoseStamped__fini(&msg->pose);
  // overfilled
  // overall_filling_level
  rc_reason_msgs__msg__CellFillingLevel__fini(&msg->overall_filling_level);
  // cells_filling_levels
  rc_reason_msgs__msg__CellFillingLevel__Sequence__fini(&msg->cells_filling_levels);
  // filling_level_cell_count
  rc_reason_msgs__msg__GridSize__fini(&msg->filling_level_cell_count);
}

bool
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__are_equal(const rc_reason_msgs__msg__LoadCarrierWithFillingLevel * lhs, const rc_reason_msgs__msg__LoadCarrierWithFillingLevel * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->id), &(rhs->id)))
  {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->type), &(rhs->type)))
  {
    return false;
  }
  // outer_dimensions
  if (!rc_reason_msgs__msg__Box__are_equal(
      &(lhs->outer_dimensions), &(rhs->outer_dimensions)))
  {
    return false;
  }
  // inner_dimensions
  if (!rc_reason_msgs__msg__Box__are_equal(
      &(lhs->inner_dimensions), &(rhs->inner_dimensions)))
  {
    return false;
  }
  // rim_thickness
  if (!rc_reason_msgs__msg__Rectangle__are_equal(
      &(lhs->rim_thickness), &(rhs->rim_thickness)))
  {
    return false;
  }
  // rim_step_height
  if (lhs->rim_step_height != rhs->rim_step_height) {
    return false;
  }
  // rim_ledge
  if (!rc_reason_msgs__msg__Rectangle__are_equal(
      &(lhs->rim_ledge), &(rhs->rim_ledge)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // overfilled
  if (lhs->overfilled != rhs->overfilled) {
    return false;
  }
  // overall_filling_level
  if (!rc_reason_msgs__msg__CellFillingLevel__are_equal(
      &(lhs->overall_filling_level), &(rhs->overall_filling_level)))
  {
    return false;
  }
  // cells_filling_levels
  if (!rc_reason_msgs__msg__CellFillingLevel__Sequence__are_equal(
      &(lhs->cells_filling_levels), &(rhs->cells_filling_levels)))
  {
    return false;
  }
  // filling_level_cell_count
  if (!rc_reason_msgs__msg__GridSize__are_equal(
      &(lhs->filling_level_cell_count), &(rhs->filling_level_cell_count)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__copy(
  const rc_reason_msgs__msg__LoadCarrierWithFillingLevel * input,
  rc_reason_msgs__msg__LoadCarrierWithFillingLevel * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__copy(
      &(input->id), &(output->id)))
  {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__copy(
      &(input->type), &(output->type)))
  {
    return false;
  }
  // outer_dimensions
  if (!rc_reason_msgs__msg__Box__copy(
      &(input->outer_dimensions), &(output->outer_dimensions)))
  {
    return false;
  }
  // inner_dimensions
  if (!rc_reason_msgs__msg__Box__copy(
      &(input->inner_dimensions), &(output->inner_dimensions)))
  {
    return false;
  }
  // rim_thickness
  if (!rc_reason_msgs__msg__Rectangle__copy(
      &(input->rim_thickness), &(output->rim_thickness)))
  {
    return false;
  }
  // rim_step_height
  output->rim_step_height = input->rim_step_height;
  // rim_ledge
  if (!rc_reason_msgs__msg__Rectangle__copy(
      &(input->rim_ledge), &(output->rim_ledge)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // overfilled
  output->overfilled = input->overfilled;
  // overall_filling_level
  if (!rc_reason_msgs__msg__CellFillingLevel__copy(
      &(input->overall_filling_level), &(output->overall_filling_level)))
  {
    return false;
  }
  // cells_filling_levels
  if (!rc_reason_msgs__msg__CellFillingLevel__Sequence__copy(
      &(input->cells_filling_levels), &(output->cells_filling_levels)))
  {
    return false;
  }
  // filling_level_cell_count
  if (!rc_reason_msgs__msg__GridSize__copy(
      &(input->filling_level_cell_count), &(output->filling_level_cell_count)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__msg__LoadCarrierWithFillingLevel *
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__LoadCarrierWithFillingLevel * msg = (rc_reason_msgs__msg__LoadCarrierWithFillingLevel *)allocator.allocate(sizeof(rc_reason_msgs__msg__LoadCarrierWithFillingLevel), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__LoadCarrierWithFillingLevel));
  bool success = rc_reason_msgs__msg__LoadCarrierWithFillingLevel__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__destroy(rc_reason_msgs__msg__LoadCarrierWithFillingLevel * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__init(rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__LoadCarrierWithFillingLevel * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__LoadCarrierWithFillingLevel *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__LoadCarrierWithFillingLevel), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__LoadCarrierWithFillingLevel__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__fini(rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence *
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * array = (rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__destroy(rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__are_equal(const rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * lhs, const rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__msg__LoadCarrierWithFillingLevel__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence__copy(
  const rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * input,
  rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__msg__LoadCarrierWithFillingLevel);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__msg__LoadCarrierWithFillingLevel * data =
      (rc_reason_msgs__msg__LoadCarrierWithFillingLevel *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__msg__LoadCarrierWithFillingLevel__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__msg__LoadCarrierWithFillingLevel__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__msg__LoadCarrierWithFillingLevel__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
