// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:msg/CellFillingLevel.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__CELL_FILLING_LEVEL__STRUCT_H_
#define RC_REASON_MSGS__MSG__DETAIL__CELL_FILLING_LEVEL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'cell_size'
#include "rc_reason_msgs/msg/detail/rectangle__struct.h"
// Member 'cell_position'
#include "geometry_msgs/msg/detail/point__struct.h"
// Member 'level_in_percent'
// Member 'level_free_in_meters'
#include "rc_reason_msgs/msg/detail/range_value__struct.h"

/// Struct defined in msg/CellFillingLevel in the package rc_reason_msgs.
/**
  * Dimensions of the 2D cell in meters
 */
typedef struct rc_reason_msgs__msg__CellFillingLevel
{
  rc_reason_msgs__msg__Rectangle cell_size;
  /// Position of the cell center in meters (either in camera or external pose frame)
  /// The z-coordinate is on the level of the load carrier rim
  geometry_msgs__msg__Point cell_position;
  /// Filling level of the cell in percent (100% represents a full cell)
  rc_reason_msgs__msg__RangeValue level_in_percent;
  /// Free space of the cell in meters (how much space is left until the cell is full)
  rc_reason_msgs__msg__RangeValue level_free_in_meters;
  /// Represents the percentage of valid pixels in this cell. Between 0 and 1
  double coverage;
} rc_reason_msgs__msg__CellFillingLevel;

// Struct for a sequence of rc_reason_msgs__msg__CellFillingLevel.
typedef struct rc_reason_msgs__msg__CellFillingLevel__Sequence
{
  rc_reason_msgs__msg__CellFillingLevel * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__msg__CellFillingLevel__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__DETAIL__CELL_FILLING_LEVEL__STRUCT_H_
