// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:msg/CollisionDetection.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__COLLISION_DETECTION__TRAITS_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__COLLISION_DETECTION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/msg/detail/collision_detection__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'pre_grasp_offset'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace rc_reason_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CollisionDetection & msg,
  std::ostream & out)
{
  out << "{";
  // member: gripper_id
  {
    out << "gripper_id: ";
    rosidl_generator_traits::value_to_yaml(msg.gripper_id, out);
    out << ", ";
  }

  // member: pre_grasp_offset
  {
    out << "pre_grasp_offset: ";
    to_flow_style_yaml(msg.pre_grasp_offset, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CollisionDetection & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: gripper_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gripper_id: ";
    rosidl_generator_traits::value_to_yaml(msg.gripper_id, out);
    out << "\n";
  }

  // member: pre_grasp_offset
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pre_grasp_offset:\n";
    to_block_style_yaml(msg.pre_grasp_offset, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CollisionDetection & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::msg::CollisionDetection & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::msg::CollisionDetection & msg)
{
  return rc_reason_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::msg::CollisionDetection>()
{
  return "rc_reason_msgs::msg::CollisionDetection";
}

template<>
inline const char * name<rc_reason_msgs::msg::CollisionDetection>()
{
  return "rc_reason_msgs/msg/CollisionDetection";
}

template<>
struct has_fixed_size<rc_reason_msgs::msg::CollisionDetection>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::msg::CollisionDetection>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::msg::CollisionDetection>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__MSG__DETAIL__COLLISION_DETECTION__TRAITS_HPP_
