// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:msg/DetectedTag.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__DETECTED_TAG__STRUCT_H_
#define RC_REASON_MSGS__MSG__DETAIL__DETECTED_TAG__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'tag'
#include "rc_reason_msgs/msg/detail/tag__struct.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.h"
// Member 'instance_id'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/DetectedTag in the package rc_reason_msgs.
/**
  * Representation of detected tag
 */
typedef struct rc_reason_msgs__msg__DetectedTag
{
  /// Header
  std_msgs__msg__Header header;
  /// Detected tag. The size will be set to the estimated tag size.
  rc_reason_msgs__msg__Tag tag;
  /// 3D pose of the detected tag
  geometry_msgs__msg__PoseStamped pose;
  /// Instance ID of the tag
  rosidl_runtime_c__String instance_id;
} rc_reason_msgs__msg__DetectedTag;

// Struct for a sequence of rc_reason_msgs__msg__DetectedTag.
typedef struct rc_reason_msgs__msg__DetectedTag__Sequence
{
  rc_reason_msgs__msg__DetectedTag * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__msg__DetectedTag__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__DETAIL__DETECTED_TAG__STRUCT_H_
