// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:msg/LoadCarrier.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER__STRUCT_H_
#define RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'id'
// Member 'type'
#include "rosidl_runtime_c/string.h"
// Member 'outer_dimensions'
// Member 'inner_dimensions'
#include "rc_reason_msgs/msg/detail/box__struct.h"
// Member 'rim_thickness'
// Member 'rim_ledge'
#include "rc_reason_msgs/msg/detail/rectangle__struct.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.h"

/// Struct defined in msg/LoadCarrier in the package rc_reason_msgs.
/**
  * This represents a detected load carrier by its geometry and its pose
 */
typedef struct rc_reason_msgs__msg__LoadCarrier
{
  rosidl_runtime_c__String id;
  /// Optional. The load carrier rim model. The only supported value is STANDARD
  rosidl_runtime_c__String type;
  /// Required
  rc_reason_msgs__msg__Box outer_dimensions;
  /// Required
  rc_reason_msgs__msg__Box inner_dimensions;
  /// Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
  rc_reason_msgs__msg__Rectangle rim_thickness;
  /// Optional. Height of the rim step for rims with an L-profile.
  double rim_step_height;
  /// Optional. Length of the rim ledge in x and y direction. This requires rim_thickness to be set.
  rc_reason_msgs__msg__Rectangle rim_ledge;
  geometry_msgs__msg__PoseStamped pose;
  /// True if a detected load carrier is overfilled. Ignored on setting load carrier.
  bool overfilled;
} rc_reason_msgs__msg__LoadCarrier;

// Struct for a sequence of rc_reason_msgs__msg__LoadCarrier.
typedef struct rc_reason_msgs__msg__LoadCarrier__Sequence
{
  rc_reason_msgs__msg__LoadCarrier * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__msg__LoadCarrier__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER__STRUCT_H_
