// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:msg/RegionOfInterest2D.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__REGION_OF_INTEREST2_D__STRUCT_H_
#define RC_REASON_MSGS__MSG__DETAIL__REGION_OF_INTEREST2_D__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'id'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/RegionOfInterest2D in the package rc_reason_msgs.
/**
  * 2D Region of Interest.
  * If width and height are both 0, the full image is covered
 */
typedef struct rc_reason_msgs__msg__RegionOfInterest2D
{
  /// id of the ROI
  rosidl_runtime_c__String id;
  /// leftmost pixel of the ROI
  uint32_t offset_x;
  /// topmost pixel of the ROI
  uint32_t offset_y;
  /// width of ROI
  uint32_t width;
  /// height of ROI.
  uint32_t height;
} rc_reason_msgs__msg__RegionOfInterest2D;

// Struct for a sequence of rc_reason_msgs__msg__RegionOfInterest2D.
typedef struct rc_reason_msgs__msg__RegionOfInterest2D__Sequence
{
  rc_reason_msgs__msg__RegionOfInterest2D * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__msg__RegionOfInterest2D__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__DETAIL__REGION_OF_INTEREST2_D__STRUCT_H_
