// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from rc_reason_msgs:msg/Tag.idl
// generated code does not contain a copyright notice

#include "rc_reason_msgs/msg/detail/tag__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
const rosidl_type_hash_t *
rc_reason_msgs__msg__Tag__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x68, 0x48, 0x4f, 0x18, 0x8b, 0x03, 0xbc, 0xe4,
      0xe9, 0xbb, 0x69, 0xe0, 0xe7, 0xe2, 0x3b, 0x1b,
      0x6d, 0x86, 0xee, 0x9b, 0xf1, 0x80, 0x26, 0x17,
      0x81, 0x85, 0x54, 0x63, 0x87, 0x35, 0xc7, 0x54,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char rc_reason_msgs__msg__Tag__TYPE_NAME[] = "rc_reason_msgs/msg/Tag";

// Define type names, field names, and default values
static char rc_reason_msgs__msg__Tag__FIELD_NAME__id[] = "id";
static char rc_reason_msgs__msg__Tag__FIELD_NAME__size[] = "size";

static rosidl_runtime_c__type_description__Field rc_reason_msgs__msg__Tag__FIELDS[] = {
  {
    {rc_reason_msgs__msg__Tag__FIELD_NAME__id, 2, 2},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {rc_reason_msgs__msg__Tag__FIELD_NAME__size, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
rc_reason_msgs__msg__Tag__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {rc_reason_msgs__msg__Tag__TYPE_NAME, 22, 22},
      {rc_reason_msgs__msg__Tag__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Tag definition\n"
  "\n"
  "# ID of the tag.\n"
  "# For april tags, it is <family>_<tag_id>.\n"
  "# Available april tag families: 16h5, 25h7, 25h9, 36h10, 36h11.\n"
  "# Example: april tag family 25h7, tag id 5: 25h7_5.\n"
  "# For QR codes, it the the data contained in the QR code.\n"
  "string id\n"
  "\n"
  "# Side length of the (quadratic) tag.\n"
  "float64 size";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
rc_reason_msgs__msg__Tag__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {rc_reason_msgs__msg__Tag__TYPE_NAME, 22, 22},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 314, 314},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
rc_reason_msgs__msg__Tag__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *rc_reason_msgs__msg__Tag__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
