// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:srv/CadMatchDetectObject.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__CAD_MATCH_DETECT_OBJECT__TRAITS_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__CAD_MATCH_DETECT_OBJECT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/srv/detail/cad_match_detect_object__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'load_carrier_compartment'
#include "rc_reason_msgs/msg/detail/compartment__traits.hpp"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'collision_detection'
#include "rc_reason_msgs/msg/detail/collision_detection__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const CadMatchDetectObject_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: template_id
  {
    out << "template_id: ";
    rosidl_generator_traits::value_to_yaml(msg.template_id, out);
    out << ", ";
  }

  // member: pose_frame
  {
    out << "pose_frame: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_frame, out);
    out << ", ";
  }

  // member: region_of_interest_id
  {
    out << "region_of_interest_id: ";
    rosidl_generator_traits::value_to_yaml(msg.region_of_interest_id, out);
    out << ", ";
  }

  // member: load_carrier_id
  {
    out << "load_carrier_id: ";
    rosidl_generator_traits::value_to_yaml(msg.load_carrier_id, out);
    out << ", ";
  }

  // member: load_carrier_compartment
  {
    out << "load_carrier_compartment: ";
    to_flow_style_yaml(msg.load_carrier_compartment, out);
    out << ", ";
  }

  // member: robot_pose
  {
    out << "robot_pose: ";
    to_flow_style_yaml(msg.robot_pose, out);
    out << ", ";
  }

  // member: collision_detection
  {
    out << "collision_detection: ";
    to_flow_style_yaml(msg.collision_detection, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CadMatchDetectObject_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: template_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "template_id: ";
    rosidl_generator_traits::value_to_yaml(msg.template_id, out);
    out << "\n";
  }

  // member: pose_frame
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose_frame: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_frame, out);
    out << "\n";
  }

  // member: region_of_interest_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "region_of_interest_id: ";
    rosidl_generator_traits::value_to_yaml(msg.region_of_interest_id, out);
    out << "\n";
  }

  // member: load_carrier_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "load_carrier_id: ";
    rosidl_generator_traits::value_to_yaml(msg.load_carrier_id, out);
    out << "\n";
  }

  // member: load_carrier_compartment
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "load_carrier_compartment:\n";
    to_block_style_yaml(msg.load_carrier_compartment, out, indentation + 2);
  }

  // member: robot_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_pose:\n";
    to_block_style_yaml(msg.robot_pose, out, indentation + 2);
  }

  // member: collision_detection
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "collision_detection:\n";
    to_block_style_yaml(msg.collision_detection, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CadMatchDetectObject_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::CadMatchDetectObject_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::CadMatchDetectObject_Request & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::CadMatchDetectObject_Request>()
{
  return "rc_reason_msgs::srv::CadMatchDetectObject_Request";
}

template<>
inline const char * name<rc_reason_msgs::srv::CadMatchDetectObject_Request>()
{
  return "rc_reason_msgs/srv/CadMatchDetectObject_Request";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::CadMatchDetectObject_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::CadMatchDetectObject_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::CadMatchDetectObject_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'matches'
#include "rc_reason_msgs/msg/detail/match__traits.hpp"
// Member 'grasps'
#include "rc_reason_msgs/msg/detail/grasp__traits.hpp"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__traits.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const CadMatchDetectObject_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: timestamp
  {
    out << "timestamp: ";
    to_flow_style_yaml(msg.timestamp, out);
    out << ", ";
  }

  // member: matches
  {
    if (msg.matches.size() == 0) {
      out << "matches: []";
    } else {
      out << "matches: [";
      size_t pending_items = msg.matches.size();
      for (auto item : msg.matches) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: grasps
  {
    if (msg.grasps.size() == 0) {
      out << "grasps: []";
    } else {
      out << "grasps: [";
      size_t pending_items = msg.grasps.size();
      for (auto item : msg.grasps) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: load_carriers
  {
    if (msg.load_carriers.size() == 0) {
      out << "load_carriers: []";
    } else {
      out << "load_carriers: [";
      size_t pending_items = msg.load_carriers.size();
      for (auto item : msg.load_carriers) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: return_code
  {
    out << "return_code: ";
    to_flow_style_yaml(msg.return_code, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CadMatchDetectObject_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: timestamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp:\n";
    to_block_style_yaml(msg.timestamp, out, indentation + 2);
  }

  // member: matches
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.matches.size() == 0) {
      out << "matches: []\n";
    } else {
      out << "matches:\n";
      for (auto item : msg.matches) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: grasps
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.grasps.size() == 0) {
      out << "grasps: []\n";
    } else {
      out << "grasps:\n";
      for (auto item : msg.grasps) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: load_carriers
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.load_carriers.size() == 0) {
      out << "load_carriers: []\n";
    } else {
      out << "load_carriers:\n";
      for (auto item : msg.load_carriers) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: return_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "return_code:\n";
    to_block_style_yaml(msg.return_code, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CadMatchDetectObject_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::CadMatchDetectObject_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::CadMatchDetectObject_Response & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::CadMatchDetectObject_Response>()
{
  return "rc_reason_msgs::srv::CadMatchDetectObject_Response";
}

template<>
inline const char * name<rc_reason_msgs::srv::CadMatchDetectObject_Response>()
{
  return "rc_reason_msgs/srv/CadMatchDetectObject_Response";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::CadMatchDetectObject_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::CadMatchDetectObject_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::CadMatchDetectObject_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const CadMatchDetectObject_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CadMatchDetectObject_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CadMatchDetectObject_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::CadMatchDetectObject_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::CadMatchDetectObject_Event & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::CadMatchDetectObject_Event>()
{
  return "rc_reason_msgs::srv::CadMatchDetectObject_Event";
}

template<>
inline const char * name<rc_reason_msgs::srv::CadMatchDetectObject_Event>()
{
  return "rc_reason_msgs/srv/CadMatchDetectObject_Event";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::CadMatchDetectObject_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::CadMatchDetectObject_Event>
  : std::integral_constant<bool, has_bounded_size<rc_reason_msgs::srv::CadMatchDetectObject_Request>::value && has_bounded_size<rc_reason_msgs::srv::CadMatchDetectObject_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<rc_reason_msgs::srv::CadMatchDetectObject_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rc_reason_msgs::srv::CadMatchDetectObject>()
{
  return "rc_reason_msgs::srv::CadMatchDetectObject";
}

template<>
inline const char * name<rc_reason_msgs::srv::CadMatchDetectObject>()
{
  return "rc_reason_msgs/srv/CadMatchDetectObject";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::CadMatchDetectObject>
  : std::integral_constant<
    bool,
    has_fixed_size<rc_reason_msgs::srv::CadMatchDetectObject_Request>::value &&
    has_fixed_size<rc_reason_msgs::srv::CadMatchDetectObject_Response>::value
  >
{
};

template<>
struct has_bounded_size<rc_reason_msgs::srv::CadMatchDetectObject>
  : std::integral_constant<
    bool,
    has_bounded_size<rc_reason_msgs::srv::CadMatchDetectObject_Request>::value &&
    has_bounded_size<rc_reason_msgs::srv::CadMatchDetectObject_Response>::value
  >
{
};

template<>
struct is_service<rc_reason_msgs::srv::CadMatchDetectObject>
  : std::true_type
{
};

template<>
struct is_service_request<rc_reason_msgs::srv::CadMatchDetectObject_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rc_reason_msgs::srv::CadMatchDetectObject_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__SRV__DETAIL__CAD_MATCH_DETECT_OBJECT__TRAITS_HPP_
