// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/DetectLoadCarriers.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__DETECT_LOAD_CARRIERS__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__DETECT_LOAD_CARRIERS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'pose_frame'
// Member 'region_of_interest_id'
// Member 'region_of_interest_2d_id'
// Member 'load_carrier_ids'
#include "rosidl_runtime_c/string.h"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in srv/DetectLoadCarriers in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__DetectLoadCarriers_Request
{
  /// Required. Pose frame for output poses (valid values are camera and external)
  rosidl_runtime_c__String pose_frame;
  /// Optional
  rosidl_runtime_c__String region_of_interest_id;
  /// Optional
  rosidl_runtime_c__String region_of_interest_2d_id;
  /// Required
  rosidl_runtime_c__String__Sequence load_carrier_ids;
  /// Required only if reference frame = external and sensor is robot-mounted
  geometry_msgs__msg__Pose robot_pose;
} rc_reason_msgs__srv__DetectLoadCarriers_Request;

// Struct for a sequence of rc_reason_msgs__srv__DetectLoadCarriers_Request.
typedef struct rc_reason_msgs__srv__DetectLoadCarriers_Request__Sequence
{
  rc_reason_msgs__srv__DetectLoadCarriers_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__DetectLoadCarriers_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__struct.h"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.h"

/// Struct defined in srv/DetectLoadCarriers in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__DetectLoadCarriers_Response
{
  builtin_interfaces__msg__Time timestamp;
  rc_reason_msgs__msg__LoadCarrier__Sequence load_carriers;
  rc_common_msgs__msg__ReturnCode return_code;
} rc_reason_msgs__srv__DetectLoadCarriers_Response;

// Struct for a sequence of rc_reason_msgs__srv__DetectLoadCarriers_Response.
typedef struct rc_reason_msgs__srv__DetectLoadCarriers_Response__Sequence
{
  rc_reason_msgs__srv__DetectLoadCarriers_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__DetectLoadCarriers_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rc_reason_msgs__srv__DetectLoadCarriers_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rc_reason_msgs__srv__DetectLoadCarriers_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/DetectLoadCarriers in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__DetectLoadCarriers_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rc_reason_msgs__srv__DetectLoadCarriers_Request__Sequence request;
  rc_reason_msgs__srv__DetectLoadCarriers_Response__Sequence response;
} rc_reason_msgs__srv__DetectLoadCarriers_Event;

// Struct for a sequence of rc_reason_msgs__srv__DetectLoadCarriers_Event.
typedef struct rc_reason_msgs__srv__DetectLoadCarriers_Event__Sequence
{
  rc_reason_msgs__srv__DetectLoadCarriers_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__DetectLoadCarriers_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__DETECT_LOAD_CARRIERS__STRUCT_H_
