// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:srv/HandEyeCalibration.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION__STRUCT_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Request __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Request __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct HandEyeCalibration_Request_
{
  using Type = HandEyeCalibration_Request_<ContainerAllocator>;

  explicit HandEyeCalibration_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit HandEyeCalibration_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Request
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Request
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HandEyeCalibration_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const HandEyeCalibration_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HandEyeCalibration_Request_

// alias to use template instance with default allocator
using HandEyeCalibration_Request =
  rc_reason_msgs::srv::HandEyeCalibration_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs


// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Response __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Response __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct HandEyeCalibration_Response_
{
  using Type = HandEyeCalibration_Response_<ContainerAllocator>;

  explicit HandEyeCalibration_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->status = 0l;
      this->message = "";
      this->error = 0.0;
      this->translation_error_meter = 0.0;
      this->rotation_error_degree = 0.0;
      this->robot_mounted = false;
    }
  }

  explicit HandEyeCalibration_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc),
    pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->status = 0l;
      this->message = "";
      this->error = 0.0;
      this->translation_error_meter = 0.0;
      this->rotation_error_degree = 0.0;
      this->robot_mounted = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _status_type =
    int32_t;
  _status_type status;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;
  using _pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _pose_type pose;
  using _error_type =
    double;
  _error_type error;
  using _translation_error_meter_type =
    double;
  _translation_error_meter_type translation_error_meter;
  using _rotation_error_degree_type =
    double;
  _rotation_error_degree_type rotation_error_degree;
  using _robot_mounted_type =
    bool;
  _robot_mounted_type robot_mounted;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__status(
    const int32_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__error(
    const double & _arg)
  {
    this->error = _arg;
    return *this;
  }
  Type & set__translation_error_meter(
    const double & _arg)
  {
    this->translation_error_meter = _arg;
    return *this;
  }
  Type & set__rotation_error_degree(
    const double & _arg)
  {
    this->rotation_error_degree = _arg;
    return *this;
  }
  Type & set__robot_mounted(
    const bool & _arg)
  {
    this->robot_mounted = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Response
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Response
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HandEyeCalibration_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->error != other.error) {
      return false;
    }
    if (this->translation_error_meter != other.translation_error_meter) {
      return false;
    }
    if (this->rotation_error_degree != other.rotation_error_degree) {
      return false;
    }
    if (this->robot_mounted != other.robot_mounted) {
      return false;
    }
    return true;
  }
  bool operator!=(const HandEyeCalibration_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HandEyeCalibration_Response_

// alias to use template instance with default allocator
using HandEyeCalibration_Response =
  rc_reason_msgs::srv::HandEyeCalibration_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Event __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Event __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct HandEyeCalibration_Event_
{
  using Type = HandEyeCalibration_Event_<ContainerAllocator>;

  explicit HandEyeCalibration_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit HandEyeCalibration_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::HandEyeCalibration_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::srv::HandEyeCalibration_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Event
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__HandEyeCalibration_Event
    std::shared_ptr<rc_reason_msgs::srv::HandEyeCalibration_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HandEyeCalibration_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const HandEyeCalibration_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HandEyeCalibration_Event_

// alias to use template instance with default allocator
using HandEyeCalibration_Event =
  rc_reason_msgs::srv::HandEyeCalibration_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{

namespace srv
{

struct HandEyeCalibration
{
  using Request = rc_reason_msgs::srv::HandEyeCalibration_Request;
  using Response = rc_reason_msgs::srv::HandEyeCalibration_Response;
  using Event = rc_reason_msgs::srv::HandEyeCalibration_Event;
};

}  // namespace srv

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION__STRUCT_HPP_
