// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/HandEyeCalibrationTrigger.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION_TRIGGER__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION_TRIGGER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/HandEyeCalibrationTrigger in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__HandEyeCalibrationTrigger_Request
{
  uint8_t structure_needs_at_least_one_member;
} rc_reason_msgs__srv__HandEyeCalibrationTrigger_Request;

// Struct for a sequence of rc_reason_msgs__srv__HandEyeCalibrationTrigger_Request.
typedef struct rc_reason_msgs__srv__HandEyeCalibrationTrigger_Request__Sequence
{
  rc_reason_msgs__srv__HandEyeCalibrationTrigger_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__HandEyeCalibrationTrigger_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'message'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/HandEyeCalibrationTrigger in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__HandEyeCalibrationTrigger_Response
{
  bool success;
  /// 0: Success
  /// 1: Saving calibration failed
  /// 2: Calibration result is not available
  /// 3: Reset successful
  int32_t status;
  rosidl_runtime_c__String message;
} rc_reason_msgs__srv__HandEyeCalibrationTrigger_Response;

// Struct for a sequence of rc_reason_msgs__srv__HandEyeCalibrationTrigger_Response.
typedef struct rc_reason_msgs__srv__HandEyeCalibrationTrigger_Response__Sequence
{
  rc_reason_msgs__srv__HandEyeCalibrationTrigger_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__HandEyeCalibrationTrigger_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rc_reason_msgs__srv__HandEyeCalibrationTrigger_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rc_reason_msgs__srv__HandEyeCalibrationTrigger_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/HandEyeCalibrationTrigger in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__HandEyeCalibrationTrigger_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rc_reason_msgs__srv__HandEyeCalibrationTrigger_Request__Sequence request;
  rc_reason_msgs__srv__HandEyeCalibrationTrigger_Response__Sequence response;
} rc_reason_msgs__srv__HandEyeCalibrationTrigger_Event;

// Struct for a sequence of rc_reason_msgs__srv__HandEyeCalibrationTrigger_Event.
typedef struct rc_reason_msgs__srv__HandEyeCalibrationTrigger_Event__Sequence
{
  rc_reason_msgs__srv__HandEyeCalibrationTrigger_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__HandEyeCalibrationTrigger_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__HAND_EYE_CALIBRATION_TRIGGER__STRUCT_H_
