// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/SilhouetteMatchDetectObject.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'object_to_detect'
#include "rc_reason_msgs/msg/detail/silhouette_match_object__struct.h"
// Member 'pose_frame'
// Member 'load_carrier_id'
#include "rosidl_runtime_c/string.h"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'collision_detection'
#include "rc_reason_msgs/msg/detail/collision_detection__struct.h"

/// Struct defined in srv/SilhouetteMatchDetectObject in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request
{
  /// Required. Object that is to be detected
  rc_reason_msgs__msg__SilhouetteMatchObject object_to_detect;
  /// Optional. Shift in meters that will be applied to the calibrated base-plane
  double offset;
  /// Required. Pose frame for output poses (valid values are camera and external)
  rosidl_runtime_c__String pose_frame;
  /// Required only if reference frame = external and sensor is robot-mounted
  geometry_msgs__msg__Pose robot_pose;
  /// Optional
  rosidl_runtime_c__String load_carrier_id;
  /// Optional. Enables collision checking of grasps with load carrier
  rc_reason_msgs__msg__CollisionDetection collision_detection;
} rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request;

// Struct for a sequence of rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request.
typedef struct rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence
{
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'matches'
#include "rc_reason_msgs/msg/detail/match__struct.h"
// Member 'grasps'
#include "rc_reason_msgs/msg/detail/grasp__struct.h"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__struct.h"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.h"

/// Struct defined in srv/SilhouetteMatchDetectObject in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response
{
  builtin_interfaces__msg__Time timestamp;
  /// List of detected matches (instances) of the object
  rc_reason_msgs__msg__Match__Sequence matches;
  rc_reason_msgs__msg__Grasp__Sequence grasps;
  rc_reason_msgs__msg__LoadCarrier__Sequence load_carriers;
  rc_common_msgs__msg__ReturnCode return_code;
} rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response;

// Struct for a sequence of rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response.
typedef struct rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence
{
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/SilhouetteMatchDetectObject in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence request;
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence response;
} rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event;

// Struct for a sequence of rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event.
typedef struct rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event__Sequence
{
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__SilhouetteMatchDetectObject_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_H_
